// This File : tb_ploopALN_prbs.v
// Date      : 11/12/2024
//
// howto : **************************************************
// howto : cat tb_ploopALN_prbs.v ploopALN.v fifo16.v encode.v decode.v par16prbs.v | grep -i timescale
// howto :
// howto : iverilog -o simulation tb_ploopALN_prbs.v ploopALN.v fifo16.v encode.v decode.v par16prbs.v
// howto : ./simulation
// howto :
// howto : cmd.exe /c vcd2fst -v tb_ploopALN_prbs.vcd -f tb_ploopALN_prbs.fst
// howto : cmd.exe /c gtkwave -W -T strobeDsp.tcl tb_ploopALN_prbs.fst tb_ploopALN_prbs.gtkw
// howto : **************************************************


`timescale 1ns / 1ps


module TopM;
  reg PCC;
  reg PSS;

  integer wcnt = 0;

  // reg  [15:0] TXDATA = 16'h0800;
  wire [15:0] TXDATA;

  wire [15:0] RXDATA;
  wire RCLK;

  reg [2:0] GSEL = 0;

  reg TX_RST = 0;
  reg RX_RST = 0;

  // wire [15:0] TXDATA_next;
  // assign TXDATA_next = TXDATA + 16'h0101;


  parameter FREQ_WCLK = 50e6;
  parameter DLY_WCLK = ((1.0 / FREQ_WCLK) / 2.0) / 1.0e-9;
  reg WCLK_OSC = 0;
  wire WCLK;
  assign #0.050 WCLK =  WCLK_OSC;

  parameter FREQ_SCLK = 212e6;
  parameter DLY_SCLK = ((1.0 / FREQ_SCLK) / 2.0) / 1.0e-9;
  reg SCLK_OSC = 0;
  wire SCLK;
  assign #0.100 SCLK =  SCLK_OSC;



  always #(DLY_WCLK) begin
    WCLK_OSC = ~WCLK_OSC;
  end

  always #(DLY_SCLK) begin
    SCLK_OSC = ~SCLK_OSC;
  end

  always @(posedge WCLK) begin
    wcnt <= wcnt + 1;
  end


  initial begin

    $display("Hello World");
    $dumpfile("tb_ploopALN_prbs.vcd");
    $dumpvars(0, TopM);
    // $dumpvars(0, TopM.xfifo.fifomem.mem);
    // $dumpvars(1, TopM.xdut.xrxcmu);

    PCC = 1'b1;
    PSS = 1'b0;

    $display("");
    $display("Hello World");
    $display("");
    $display("Running : ");
    $display("");



  end



  always @(negedge WCLK) begin

    // TXDATA <= TXDATA_next;

    if ((wcnt % 100) == 0) begin
      $display("PROGRESS %8.2f : %d", $realtime, wcnt);
    end

    if (wcnt < 400) begin
      if ((wcnt % 15) == 0) begin
        GSEL <= GSEL + 1;
      end
    end
    else begin
      GSEL = 4;
    end


    if (wcnt == 10) begin
      TX_RST <= 1;
      RX_RST <= 1;
    end

    if (wcnt == 14) begin
      TX_RST <= 0;
      RX_RST <= 0;
    end


    if (wcnt == 800) begin
      $display("");
      $display("Done");
      $display("");

      $finish;
    end


  end

  reg [1:0] PSEL = 0;
  reg       INVD = 0;
  wire      ERR;
  

  par16prbs xGen (
    .QOUT(TXDATA),
    .PSEL(PSEL),
    .INVD(INVD),
    .RST(TX_RST),
    .CLK(WCLK),
    .PCC(PCC),
    .PSS(PSS)
  );

  par16qrbs xChk (
    .ERR(ERR),
    .DIN(RXDATA),
    .PSEL(PSEL),
    .INVD(INVD),
    .RST(RX_RST),
    .CLK(RCLK),
    .PCC(PCC),
    .PSS(PSS)
  );


  ploopALN xDut (
   .ZDAT(RXDATA),
   .ZCLK(RCLK),

   .WDAT(TXDATA),
   .WCLK(WCLK),

   .SCLK(SCLK),

   .GSEL(GSEL),

   .TX_RST(TX_RST),
   .RX_RST(RX_RST),

   .PCC(PCC),
   .PSS(PSS)

  );



endmodule


// * ****************************************************

